<template>
    <el-container style="height: 100%">
        <el-header>
            <commonheader></commonheader>
        </el-header>
        <el-container>
            <el-aside width="auto">
                <commonaside></commonaside>
            </el-aside>
            <el-main>
                <!--左侧栏 和 header部分对于整个后台部分都是不变的，唯一变的就是上面3的部分，这里就通过router-view来展示所需控件-->
                <div v-if="!islogin" style="color:#909399;position:relative;top:35%;text-align:center">
                    您还没有登录，请先登录!
                </div>
                <div v-if="islogin" style="width:50%;position:relative;left:25%;top:10%">
                    <el-form :model="ruleForm" :rules="rules" ref="ruleForm" label-width="100px" class="demo-ruleForm">
                        <el-form-item label="您的身高" prop="userHeight">
                            <el-input v-model="ruleForm.userHeight" placeholder="请输入您的身高(单位厘米，整数即可)"></el-input>
                        </el-form-item>
                        <el-form-item label="您的体重" prop="userWeight">
                            <el-input v-model="ruleForm.userWeight" placeholder="请输入您的体重(单位千克，整数即可)"></el-input>
                        </el-form-item>
                        <el-form-item label="您的年龄" prop="userAge">
                            <el-input v-model="ruleForm.userAge" placeholder="请输入您的年龄"></el-input>
                        </el-form-item>
                        <el-form-item label="您的性别" prop="userSex">
                            <el-input v-model="ruleForm.userSex" placeholder="请输入您的性别(male/female)"></el-input>
                        </el-form-item>
                        <el-form-item label="活动倾向">
                          <el-radio-group v-model="ruleForm.userQuantityPrefer">
                            <el-radio label="0" style="height:25px">卧床（全天）</el-radio><br>
                            <el-radio label="1" style="height:25px">轻活动（多坐、缓步）</el-radio><br>
                            <el-radio label="2" style="height:25px">一般活动度</el-radio><br>
                            <el-radio label="3" style="height:25px">活动量大</el-radio>
                          </el-radio-group>
                        </el-form-item>
                        <el-row type="flex" class="row-bg" justify="space-around">
                            <el-col :span="6">
                                <el-popover placement="top" width="200" v-model="visible" title="更改失败，请检查输入！" trigger="manual">
                                  <p>{{changeMsg}}</p>
                                  <div style="text-align: right; margin: 0">
                                    <el-button type="primary" size="mini" @click="visible=false">确定</el-button>
                                  </div>
                                  <el-button slot="reference" type="danger" @click="changeinfo()">立即更改</el-button>
                                </el-popover>
                            </el-col>
                        </el-row>
                    </el-form>
                </div>
            </el-main>
        </el-container>
    </el-container>
</template>

<script>
import commonaside from '../components/commonaside.vue'
import commonheader from '../components/commonheader.vue'
import showViewInfoService from '@/services/showViewInfoService'
import changehealthinfo from '@/services/changehealthinfo'
export default {
  components: {
    commonaside,
    commonheader
  },
  data () {
    var checkIsHeight = (rule, value, callback) => {
      const IsNum = /^[1-9][0-9]*$/
      if (IsNum.test(value) && value <= 300) {
        this.isValidatedHeight = true
        return callback()
      } else {
        this.isValidatedHeight = false
        callback(new Error('请输入正确身高 (不应超过 300 厘米)'))
      }
    }
    var checkIsWeight = (rule, value, callback) => {
      const IsNum = /^[1-9][0-9]*$/
      if (IsNum.test(value) && value <= 1000) {
        this.isValidatedWeight = true
        return callback()
      } else {
        this.isValidatedHeight = false
        callback(new Error('请输入正确体重 (不应超过 1000 千克)'))
      }
    }
    var checkIsAge = (rule, value, callback) => {
      const IsNum = /^[1-9][0-9]*$/
      if (IsNum.test(value) && value <= 150) {
        this.isValidatedAge = true
        return callback()
      } else {
        this.isValidatedAge = false
        callback(new Error('请输入正确年龄 (不应超过 200)'))
      }
    }
    var checkIsSex = (rule, value, callback) => {
      if (value === 'male' || value === 'female') {
        this.isValidatedSex = true
        return callback()
      } else {
        this.isValidatedSex = false
        callback(new Error('应该输入male/female'))
      }
    }
    return {
      visible: false,
      changeMsg: '',
      islogin: false,
      userInfo: [{}],
      ruleForm: {
        userHeight: '',
        userWeight: '',
        userAge: '',
        userSex: '',
        userQuantityPrefer: '0'
      },
      isValidatedSex: false,
      isValidatedHeight: false,
      isValidatedWeight: false,
      isValidatedAge: false,
      rules: {
        userHeight: [
          { required: true, validator: checkIsHeight, trigger: 'blur' }
        ],
        userWeight: [
          { required: true, validator: checkIsWeight, trigger: 'blur' }
        ],
        userAge: [
          { required: true, validator: checkIsAge, trigger: 'blur' }
        ],
        userSex: [
          { required: true, validator: checkIsSex, trigger: 'blur' }
        ]
      }
    }
  },
  created () {
    this.getUserInfo()
    this.islogin = this.$store.state.token !== ''
    this.ruleForm.userHeight = this.userInfo.userHeight
    this.ruleForm.userWeight = this.userInfo.userWeight
    this.ruleForm.userAge = this.userInfo.userAge
    this.ruleForm.userSex = this.userInfo.userSex
  },
  methods: {
    async getUserInfo () {
      try {
        const response = await showViewInfoService.getInfo(
          {
            headers: {'Authorization': this.$store.state.token}
          })
        // console.log(response.data)
        this.userInfo = response.data.data.user
      } catch (error) {
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          this.error = 'Network Error'
        } else {
          this.error = error.response.data.error
        }
      }
    },
    async changeinfo () {
      try {
        if (!this.isValidatedSex || !this.isValidatedHeight || !this.isValidatedWeight || !this.isValidatedAge) {
          this.visible = true
          return
        }
        const response = await changehealthinfo.changeinfo({
          userHeight: parseInt(this.ruleForm.userHeight),
          userWeight: parseInt(this.ruleForm.userWeight),
          userAge: parseInt(this.ruleForm.userAge),
          userSex: this.ruleForm.userSex
        },
        {
          headers: {'Authorization': this.$store.state.token}
        })
        const response2 = await changehealthinfo.setQuantityPrefer({
          userWorkoutQuantityPrefer: parseInt(this.ruleForm.userQuantityPrefer)
        },
        {
          headers: {'Authorization': this.$store.state.token}
        })
        console.log(response.data)
        console.log(response2.data)
        if (response.data.code === 200) {
          this.$alert('您的信息已经成功更新！', '更改成功', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              this.$router.push('/showviewinfo')
            }
          })
          console.log(this.visible)
          return
        } else {
          this.visible = true
          this.changeMsg = response.data.msg
        }
      } catch (error) {
        this.visible = true
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          this.changeMsg = '网络异常！'
          this.error = 'Network Error'
        } else {
          this.changeMsg = error.response.data.msg
          this.error = error.response.data.error
        }
      }
    }
  }
}
</script>

<style scoped>
.el-header {
    background-color: #333;
}
.el-main {
    padding-top: 0;
}
</style>
